%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 0
# No tests provided
%global with_check 0
%global with_unit_test 0
%else
%global with_devel 0
%global with_bundled 0
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global provider        github
%global provider_tld    com
%global project         kr
%global repo            pty
# https://github.com/kr/pty
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          f7ee69f31298ecbe5d2b349c711e2547a617d398
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-github-kr-pty
Version:        0
Release:        0.31.git%{shortcommit}%{?dist}
Summary:        PTY interface for Go
License:        MIT
URL:            https://godoc.org/%{import_path}
Source0:        https://%{provider_prefix}/archive/%{commit}/pty-%{shortcommit}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%description
Pty is a Go package for using UNIX pseudo-terminals.

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check}
%endif

Provides:      golang(%{import_path}) = %{version}-%{release}

%description devel
Pty is a Go package for using UNIX pseudo-terminals.

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%package unit-test
Summary:         Unit tests for %{name} package
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}

%build

%install
# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test} && 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%else
export GOPATH=%{buildroot}/%{gopath}:$(pwd)/Godeps/_workspace:%{gopath}
%endif

%if ! 0%{?gotest:1}
%global gotest go test
%endif

%endif

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%if 0%{?with_devel}
%files devel -f devel.file-list
%license License
%doc README.md
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%files unit-test -f unit-test.file-list
%license License
%doc README.md
%endif

%changelog
* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.31.gitf7ee69f
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Jul 21 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.30.gitf7ee69f
- https://fedoraproject.org/wiki/Changes/golang1.7

* Thu Mar 03 2016 jchaloup <jchaloup@redhat.com> - 0-0.29.gitf7ee69f
- Fix fedora macro
  resolves: #1313956

* Sat Feb 27 2016 Peter Robinson <pbrobinson@fedoraproject.org> 0-0.28.gitf7ee69f
- Bump to upstream f7ee69f31298ecbe5d2b349c711e2547a617d398 (add aarch64 support)

* Mon Feb 22 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.27.git05017fc
- https://fedoraproject.org/wiki/Changes/golang1.6

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.26.git05017fc
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sat Sep 12 2015 jchaloup <jchaloup@redhat.com> - 0-0.25.git05017fc
- Update to spec-2.1
  related: #1254595

* Wed Aug 12 2015 Fridolin Pokorny <fpokorny@redhat.com> - 0-0.24.git05017fc
- Update spec file to spec-2.0
  resolves: #1254595

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.23.git05017fc
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Feb 25 2015 jchaloup <jchaloup@redhat.com> - 0-0.22.git05017fc
- Bump to upstream 05017fcccf23c823bfdea560dcc958a136e54fb7
  related: #1001396

* Thu Jul 31 2014 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0.21.git
- do not own dirs owned by golang
- archfulness and defattr for el6 only

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.20.git67e2db2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat May 31 2014 Lokesh Mandvekar <lsm5@redhat.com> 0-0.19.git
- update to commit 67e2db24c8 (required for docker 1.0
https://github.com/dotcloud/docker/issues/5908 )

* Wed Jan 15 2014 Lokesh Mandvekar <lsm5@redhat.com> 0-0.18.git3b1f648
- exclusivearch for el6+

* Wed Jan 15 2014 Lokesh Mandvekar <lsm5@redhat.com> 0-0.17.git3b1f648
- revert golang >= 1.2 version requirement

* Wed Jan 15 2014 Lokesh Mandvekar <lsm5@redhat.com> 0-0.16.git3b1f648
- require golang 1.2 and up

* Wed Oct 16 2013 Lokesh Mandvekar <lsm5@redhat.com> 0-0.15.git3b1f648
- removed double quotes from provides

* Tue Oct 08 2013 Lokesh Mandvekar <lsm5@redhat.com> 0-0.14.git3b1f648
- noarch for f19+ and rhel7+, exclusivearch otherwise

* Mon Oct 07 2013 Lokesh Mandvekar <lsm5@redhat.com> 0-0.13.git3b1f648
- exclusivearch as per golang

* Sun Oct 06 2013 Lokesh Mandvekar <lsm5@redhat.com> 0-0.12.git3b1f648
- excluded for ppc64
- debug_package nil

* Wed Oct 02 2013 Lokesh Mandvekar <lsm5@fedoraproject.org> 0-0.11.git3b1f648
- docker first run error fix

* Sun Sep 22 2013 Matthew Miller <mattdm@fedoraproject.org> 0-0.10.git27435c6
- install just the source code for devel package

* Tue Sep 17 2013 Lokesh Mandvekar <lsm5@redhat.com> 0-0.9.git27435c6
- version format changed
- docdir unversioned

* Mon Sep 16 2013 Lokesh Mandvekar <lsm5@redhat.com> git27435c6-8
- No debuginfo generated, was empty to begin with
- package owns all directories in import_path

* Mon Sep 16 2013 Lokesh Mandvekar <lsm5@redhat.com> git27435c6-7
- only devel package generated
- Provides moved to devel package
- docdir modified

* Wed Sep 11 2013 Lokesh Mandvekar <lsm5@redhat.com> git27435c6-6
- rm from install section removed

* Tue Sep 10 2013 Lokesh Mandvekar <lsm5@redhat.com> git27435c6-5
- cleanup in prep and build as per guidelines

* Tue Sep 10 2013 Lokesh Mandvekar <lsm5@redhat.com> git27435c6-4
- Build under all circumstances
- Go pkg archives handled (thanks to Vincent Batts (vbatts@redhat.com)

* Thu Aug 29 2013 Lokesh Mandvekar <lsm5@redhat.com> 0.0.1-3
- Devel package generated

* Wed Aug 28 2013 Lokesh Mandvekar <lsm5@redhat.com> 0.0.1-2
- Fixed permissions

* Mon Aug 26 2013 Lokesh Mandvekar <lsm5@redhat.com> 0.0.1-1
- Initial fedora package

